scoreboard players operation chaos_core_difficulty_before chaos_core_difficulty_score = chaos_core_difficulty chaos_core_difficulty_score
execute as @a[scores={chaos_core_set_difficulty_auto=1..}] run tellraw @a "[Chaos Core] Auto difficulty triggered"
execute as @a[scores={chaos_core_set_difficulty_easy=1..}] run tellraw @a "[Chaos Core] Easy difficulty triggered"
execute as @a[scores={chaos_core_set_difficulty_normal=1..}] run tellraw @a "[Chaos Core] Normal difficulty triggered"
execute as @a[scores={chaos_core_set_difficulty_hard=1..}] run tellraw @a "[Chaos Core] Hard difficulty triggered"
execute as @a[scores={chaos_core_set_difficulty_chaos=1..}] run tellraw @a "[Chaos Core] Chaos difficulty triggered"

execute as @a[scores={chaos_core_set_difficulty_auto=1..}] run scoreboard players reset chaos_core_difficulty_override chaos_core_difficulty_score
execute as @a[scores={chaos_core_set_difficulty_easy=1..}] run scoreboard players set chaos_core_difficulty_override chaos_core_difficulty_score 0
execute as @a[scores={chaos_core_set_difficulty_normal=1..}] run scoreboard players set chaos_core_difficulty_override chaos_core_difficulty_score 1
execute as @a[scores={chaos_core_set_difficulty_hard=1..}] run scoreboard players set chaos_core_difficulty_override chaos_core_difficulty_score 2
execute as @a[scores={chaos_core_set_difficulty_chaos=1..}] run scoreboard players set chaos_core_difficulty_override chaos_core_difficulty_score 3

scoreboard players set @a chaos_core_set_difficulty_auto 0
scoreboard players set @a chaos_core_set_difficulty_easy 0
scoreboard players set @a chaos_core_set_difficulty_normal 0
scoreboard players set @a chaos_core_set_difficulty_hard 0
scoreboard players set @a chaos_core_set_difficulty_chaos 0

scoreboard players enable @a chaos_core_set_difficulty_auto
scoreboard players enable @a chaos_core_set_difficulty_easy
scoreboard players enable @a chaos_core_set_difficulty_normal
scoreboard players enable @a chaos_core_set_difficulty_hard
scoreboard players enable @a chaos_core_set_difficulty_chaos

execute if score chaos_core_difficulty_override chaos_core_difficulty_score matches 0..3 run scoreboard players operation chaos_core_difficulty chaos_core_difficulty_score = chaos_core_difficulty_override chaos_core_difficulty_score
execute unless score chaos_core_difficulty_before chaos_core_difficulty_score = chaos_core_difficulty chaos_core_difficulty_score run return run function chaos:difficulty_changed
execute if score chaos_core_difficulty_override chaos_core_difficulty_score matches 0..3 run return 0

execute as @a run function chaos:get_difficulty_score

scoreboard players set chaos_core_highest_difficulty_score chaos_core_difficulty_score 0
execute as @a run scoreboard players operation chaos_core_highest_difficulty_score chaos_core_difficulty_score > @s chaos_core_difficulty_score

execute if score chaos_core_highest_difficulty_score chaos_core_difficulty_score matches 0.. run scoreboard players set chaos_core_difficulty chaos_core_difficulty_score 0
execute if score chaos_core_highest_difficulty_score chaos_core_difficulty_score matches 15.. run scoreboard players set chaos_core_difficulty chaos_core_difficulty_score 1
execute if score chaos_core_highest_difficulty_score chaos_core_difficulty_score matches 30.. run scoreboard players set chaos_core_difficulty chaos_core_difficulty_score 2
execute if score chaos_core_highest_difficulty_score chaos_core_difficulty_score matches 50.. run scoreboard players set chaos_core_difficulty chaos_core_difficulty_score 3


execute unless score chaos_core_difficulty_before chaos_core_difficulty_score = chaos_core_difficulty chaos_core_difficulty_score run function chaos:difficulty_changed

scoreboard players reset chaos_core_highest_difficulty_score chaos_core_difficulty_score